/*****************************************************************************/
/* X2File.CPP  UnPack a .DDI .DCF .IMG format file.              <TC++\BC++> */
/* Version 0.20                   Nov,1995                    Lee Dong-Liang */
/*****************************************************************************/

#include <io.h>
#include <bios.h>
#include <dos.h>
#include <dir.h>
#include <iostream.h>
#include <stdlib.h>
#include <alloc.h>
#include <math.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>
#include <mem.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <debug.ipp>

int atexit(void func());                  /* Fix bugs in atexit */
                                          /* use  atexit((void) (*function)) */
#define MacTrackNumber  160

#define  N_A            '\x61\x1E'
#define  N_O            '\x6F\x18'
#define  N_P            '\x70\x19'
#define  N_Q            '\x71\x10'
#define  N_S            '\x73\x1F'
#define  S_A            '\x41\x1E'
#define  S_O            '\x4F\x18'
#define  S_P            '\x50\x19'
#define  S_Q            '\x51\x10'
#define  S_S            '\x53\x1F'
#define  C_C            '\x03\x2E'

enum DISKSIZE { Disk_unknow =    0 ,
                Disk_320    =  320 ,
                Disk_360    =  360 ,
                Disk_400    =  400 ,
                Disk_720    =  720 ,
                Disk_800    =  800 ,
                Disk_1200   = 1200 ,
                Disk_1360   = 1360 ,
                Disk_1440   = 1440 ,
                Disk_1680   = 1680 ,
                Disk_2880   = 2880   };

typedef struct
   {
/**/           char  jmp_exe_code[3];  /* jump to executable code            */
/**/           char  OEM_version[8];   /* OEM name and version               */
/**/  unsigned int   sectorbytes;      /* bytes per sector                   */
/**/  unsigned char  clustersize;      /* allocation unit size (in sector)   */
/**/  unsigned int   reservedsize;     /* reserved sectors (starting at 0)   */
/**/  unsigned char  FATnumber;        /* number of FAT's on disk            */
/**/  unsigned int   rootentry;        /* number of root directory entries   */
/**/  unsigned int   totalsector;      /* total sectors(0 if partition>32Mb) */
/**/  unsigned char  mediatype;        /* media descriptor byte              */
/**/  unsigned int   FATsize;          /* sectors per FAT                    */
/**/  unsigned int   tracksize;        /* sectors per track        (DOS 3.0+)*/
/**/  unsigned int   headnumber;       /* number of heads          (DOS 3.0+)*/
/**/  unsigned int   hiddensize;       /* number of hidden sectors (DOS 3.0+)*/
      unsigned long  totalsector2;     /* number of sectors if >32Mb (DOS 4+)*/
      unsigned char  reserved[2];      /* reserved                   (DOS 4+)*/
      unsigned char  drivenumber;      /* physical drive number      (DOS 4+)*/
      unsigned char  reserved2;        /* reserved                   (DOS 4+)*/
/**/  unsigned char  signature;        /* signature byte (29h)       (DOS 4+)*/
/**/  unsigned long  serialnumber;     /* volume serial number       (DOS 4+)*/
/**/           char  volumelabel[11];  /* volume label               (DOS 4+)*/
/**/           char  filesysID[8];     /* file system ID "FAT?????"  (DOS 4+)*/
   }  BOOTSEC;

typedef struct                /* 76543210 File's attribute:  */
   {                          /*          read only        */
      unsigned readonly :1;   /*         hidden            */
      unsigned hidden   :1;   /*        system             */
      unsigned system   :1;   /*       volume label        */
      unsigned volume   :1;   /*      subdirectory         */
      unsigned directory:1;   /*     archive               */
      unsigned archive  :1;   /*   unused                 */
      unsigned unused   :2;
   }  FileAttr;
typedef struct         /*FEDCBA9876543210 Directory Time Format*/
   {                   /*             seconds            */
      unsigned sec:5;  /*                 (2 second increments)      */
      unsigned min:6;  /*       minutes (0-59)      */
      unsigned hour:5; /*  hours (0-23)         */
   }  FileTime;
typedef struct         /*FEDCBA9876543210 Directory Date Format*/
   {                   /*             Day (1-31)         */
      unsigned day:5;  /*         Month (1-12)        */
      unsigned mon:4;  /*  Year (less 1980)     */
      unsigned year:7;
   }  FileDate;
typedef struct
   {
      char filename[8];             /* Filename, left justified            */
      char fileext[3];              /* Filename extension, left justified  */
      union{FileAttr fa;            /* File's attribute                    */
            unsigned char fileattr;};
      char reserved[10];            /* Reserved by DOS                     */
      union{FileTime ft;            /* Time the file                       */
            unsigned int filetime;};
      union{FileDate fd;            /* Date the file                       */
            unsigned int filedate;};
      unsigned int  startcluster;   /* Starting cluster number of the file */
               long filesize;       /* File size in bytes                  */
   }  Directory;

long GetDiskState(char Driver,char Fflag)
{
   unsigned sectorpercluster;
   unsigned freeclusters;
   unsigned bytepersector;

   Driver=(Driver>='a' && Driver<='z')?Driver-'a'+'A':Driver; /* to Upper */
   Driver=(Driver>='A' && Driver<='Z')?Driver-'A'+1:0;   /* if not A-Z set 0 */
   asm{  mov   dl,Driver            /* 0->current, 1->A, 2->B, 3->C,... */
         mov   ah,036h
         int   21h
         mov   sectorpercluster,ax
         mov   freeclusters,bx
         mov   bytepersector,cx  };

   if(Fflag==1)      // return free space in bytes
      return ((long)freeclusters*(long)sectorpercluster*(long)bytepersector);
   else              // return the minimum unit in bytes
      return ((long)sectorpercluster*(long)bytepersector);
}
inline long GetDiskFreeSpace(char Driver)
{
   return GetDiskState(Driver,1);
}
char SetFileAttribute(char far *filename,unsigned attr)
{
   unsigned int fseg=FP_SEG(filename);
   unsigned int foff=FP_OFF(filename);
   char err=1;
   asm{  push  ds
         mov   ax,04301h
         mov   ds,fseg
         mov   dx,foff
         mov   cx,attr
         int   21h
         jc    errSetfileattr
         mov   err,0          };
errSetfileattr:
   asm{  pop   ds             };
   return err;
}
char SetFileDateTime(int fhandle,unsigned int fdate,unsigned int ftime)
{
   char err=1;
   asm{  mov   ah,057h
         mov   al,01h
         mov   bx,fhandle
         mov   cx,ftime
         mov   dx,fdate
         int   021h
         jc    errSetfiledatetime
         mov   err,0                };
errSetfiledatetime:
   return err;
}
void killspace(char *c)
{
   int slen=strlen(c);
   for(int i=slen-1;i>=0;i--)
      if(c[i]!=' ')
      {
         c[i+1]='\0';
         break;
      }
}
inline void addpathname(char *cp,char *fname,char *fext)
{
   strncat(cp,fname,8);killspace(cp);
   strcat(cp,".");
   strncat(cp,fext,3); killspace(cp);
   strcat(cp,"\\");
   int slen=strlen(cp);
   if(cp[slen-1-1]=='.')
      cp[slen-1-1]='\\', cp[slen-1]='\0';
}
void killpathname(char *cp)
{
   for(int j=strlen(cp)-1-1;j>=0;j--)
      if(cp[j]=='\\')
      {
         cp[j+1]='\0';
         break;
      }
}
void MakeDir(char *cp)
{
   char *currdpath=new char[300];
   strcpy(currdpath,"D:\\");currdpath[0]=toupper(cp[0]);
   getcurdir(currdpath[0]-'A'+1,currdpath+3);
   int slen=strlen(cp);
   if(cp[slen-1]=='\\')
   {
      cp[slen-1]='\0';
      if(chdir(cp)!=0)
      {
         if(mkdir(cp)!=0) MakeDirError();
      }
      cp[slen-1]='\\'; cp[slen]='\0';
   }
   else  if(chdir(cp)!=0)
         {
            if(mkdir(cp)!=0) MakeDirError();
         }
   slen=strlen(currdpath);
   if(currdpath[slen-1]=='\\' && currdpath[slen-2]!=':') currdpath[slen-1]='\0';
   chdir(currdpath);
   delete [] currdpath;
}




#ifndef __FILEX_CLASS_                // Class FileX
class FileX
{
public:
   FILE *pfile;                  /* the pointer of the data file       */
   char *strFilename;            /* the data file name                 */
   DISKSIZE disksize;            /* disksize in KBytes                 */
   uint  BytePerSector;          /* bytes per sector                   */
   byte  SectorPerCluster;       /* allocation unit size (in sector)   */
   uint  ReservedSector;         /* reserved sectors (starting at 0)   */
   byte  FATnumber;              /* number of FAT's on disk            */
   uint  ROOTEntry;              /* number of root directory entries   */
   uint  TotalSector;            /* total sectors(0 if partition>32Mb) */
   uint  SectorPerFAT;           /* sectors per FAT                    */
   uint  SectorPerTrack;         /* sectors per track        (DOS 3.0+)*/
   uint  TotalTrack;             /* total track number of a disk       */
   int   *FATchain,totalFAT;     /* FATchain & totalFAT */
   char  *FATchainUsedMark;      /* FAT chain Used Mark */


   FileX();
   ~FileX();
   flag fCheckFileValid(void)    {  return 0;   };
   DISKSIZE GetDiskSize(void)    {  return Disk_1440; };
   void SetDiskSize(DISKSIZE d)  {  disksize=d; };
   flag fReadDiskSector(void *buff,int sectornumber,long sectoroffset);
   flag fSetDiskDefaultParameter(DISKSIZE d);
   flag fReadBOOT(BOOTSEC *b);
   void ResetDiskParameter(BOOTSEC &b);
   flag fCompareFAT(void);
   void ConvertFAT(void);
   flag fReadFileCluster();
};
#endif
#ifndef __FILEX_CLASS_                // Class FileX
#define __FILEX_CLASS_                // Class FileX
#endif
flag FileX::fReadDiskSector(void *buff,int sectornumber,long sectoroffset)
{
   for(int i=0;i<sectornumber;i++)
   {
      if(fseek(fp,(sectoroffset+i)*BytePerSector,SEEK_SET)!=0)      return -1;
      if(fread((char *)buff+i*BytePerSector,BytePerSector,1,fp)!=1) return -1;
   }
   return 0;
}
flag FileX::fSetDiskDefaultParameter(DISKSIZE d)
{
   switch(d)
   {
      case Disk_320    :   BytePerSector   =512;      SectorPerCluster=2;
                           ReservedSector  =1;        FATnumber       =2;
                           ROOTEntry       =112;      TotalSector     =640;
                           SectorPerFAT    =1;        SectorPerTrack  =8;
                           TotalTrack      =40*2;
                           break;
      case Disk_360    :   BytePerSector   =512;      SectorPerCluster=2;
                           ReservedSector  =1;        FATnumber       =2;
                           ROOTEntry       =112;      TotalSector     =720;
                           SectorPerFAT    =2;        SectorPerTrack  =9;
                           TotalTrack     =40*2;
                           break;
//    case Disk_400    :   TotalTrack     =40*2;
      case Disk_720    :   BytePerSector   =512;      SectorPerCluster=2;
                           ReservedSector  =1;        FATnumber       =2;
                           ROOTEntry       =112;      TotalSector     =1440;
                           SectorPerFAT    =3;        SectorPerTrack  =9;
                           TotalTrack     =80*2;
                           break;
//    case Disk_800    :   TotalTrack     =80*2;
      case Disk_1200   :   BytePerSector   =512;      SectorPerCluster=1;
                           ReservedSector  =1;        FATnumber       =2;
                           ROOTEntry       =224;      TotalSector     =2400;
                           SectorPerFAT    =7;        SectorPerTrack  =15;
                           TotalTrack     =80*2;
                           break;
      case Disk_1360   :   BytePerSector   =512;      SectorPerCluster=1;
                           ReservedSector  =1;        FATnumber       =2;
                           ROOTEntry       =224;      TotalSector     =2720;
                           SectorPerFAT    =7;        SectorPerTrack  =17;
                           TotalTrack     =80*2;
                           break;
      case Disk_1440   :   BytePerSector   =512;      SectorPerCluster=1;
                           ReservedSector  =1;        FATnumber       =2;
                           ROOTEntry       =224;      TotalSector     =2880;
                           SectorPerFAT    =9;        SectorPerTrack  =18;
                           TotalTrack     =80*2;
                           break;
      case Disk_1680   :   BytePerSector   =512;      SectorPerCluster=1;
                           ReservedSector  =1;        FATnumber       =2;
                           ROOTEntry       =224;      TotalSector     =3360;
                           SectorPerFAT    =10;       SectorPerTrack  =21;
                           TotalTrack     =80*2;
                           break;
      case Disk_2880   :   BytePerSector   =512;      SectorPerCluster=2;
                           ReservedSector  =1;        FATnumber       =2;
                           ROOTEntry       =240;      TotalSector     =5760;
                           SectorPerFAT    =9;        SectorPerTrack  =36;
                           TotalTrack     =80*2;
                           break;
      case Disk_unknow :
      default          :   Icannothandle();  return 1;
   }
   return 0;
}
flag FileX::fReadBOOT(BOOTSEC *b)
{
   char *t=new char[BytePerSector];    MemoryNotEnough(t);
   fReadDiskSector(t,1,0L);
   memcpy(b,t,sizeof(BOOTSEC));
   delete [] t;
   char resultreadboot=0;
   if((long)b->sectorbytes*(long)b->totalsector > (long)disksize*1024L)resultreadboot=1;
   if(    b->FATsize>  18)resultreadboot=2;
   if(  b->FATnumber>   4)resultreadboot=3;
   if(b->sectorbytes>1024)resultreadboot=4;
   if(b->clustersize>  16)resultreadboot=5;
// if(resultreadboot)   BootDataError();
   return resultreadboot;
}
void FileX::ResetDiskParameter(BOOTSEC &b)
{
   BytePerSector   =b.sectorbytes ;
   SectorPerCluster=b.clustersize ;
   ReservedSector  =b.reservedsize;
   FATnumber       =b.FATnumber   ;
   ROOTEntry       =b.rootentry   ;
   TotalSector     =b.totalsector ;
   SectorPerFAT    =b.FATsize     ;
   SectorPerTrack  =b.tracksize   ;
}
flag FileX::fCompareFAT(void)
{
   char compareresult=0;
   char *firstFAT,*secondFAT;
   firstFAT =new char[SectorPerFAT*BytePerSector]; MemoryNotEnough(firstFAT);
   secondFAT=new char[SectorPerFAT*BytePerSector]; MemoryNotEnough(secondFAT);
   ReadDiskSector(firstFAT ,SectorPerFAT,             1L,ddifile);
   ReadDiskSector(secondFAT,SectorPerFAT,SectorPerFAT+1L,ddifile);

   if(memcmp(firstFAT,secondFAT,SectorPerFAT*BytePerSector)!=0)
      compareresult=1;

   delete [] firstFAT;
   delete [] secondFAT;

   return compareresult;
}
void FileX::ConvertFAT(void)
{
   union
   {
      struct{  unsigned f1:12;            /* FAT 12 */
               unsigned f2:12;   }f;
      char a[3];
   };
   char *firstFAT;
   int i,j;
   firstFAT =new char[SectorPerFAT*BytePerSector]; MemoryNotEnough(firstFAT);
   fReadDiskSector(firstFAT,SectorPerFAT,1L);
   for(j=0;j<totalfat/2;j++)
   {
      for(i=0;i<3;i++) a[i]=firstFAT[i+j*3];
      fatchain[j*2]  =f.f1;
      fatchain[j*2+1]=f.f2;
   }
   delete [] firstFAT;
}
void FileX::ReadFileCluster(void *buf,uint clusterno)
{
   if(FlagofForceExtract)     // Ver 0.14 ]wj
   {
      if(clusterno>totalFAT && clusterno<0x0FF0) // WLF̤jXk ver 0.14
      {
         memset(buf,0,SectorPerCluster*BytePerSector);   // NƳ]
         return;
      }
      // w ForceExtract ɡAΰO FAT ϥΪA
   }
   else
   {
      if(clusterno>totalFAT && clusterno<0x0FF0) // WLF̤jXk ver 0.14
      {
         FATDataTooBig();
         exit(1);
      }
      if(FATchainUsedMark[clusterno]!=0)  // == 0 ܨSιL FAT clusterno
      {
         FATCrossLinking();
         exit(1);
      }
      FATchainUsedMark[clusterno]=1;   // ]wιL FAT clusterno ver 0.14
   }

   long secoffs = ReservedSector                                // BOOT
                + FATnumber*SectorPerFAT                        // FAT
                + ROOTEntry/(BytePerSector/sizeof(Directory))   // ROOT
                + (clusterno-2)*SectorPerCluster;               // DATA
   fReadDiskSector(buf,SectorPerCluster,secoffs);
}








char inchinesesystem;                  /* flag of in Chinese System */
char FlagofExitError;                  /* flag of Error on EXIT v0.13 */
char FlagofError_NotExit;              /* flag of Error but not EXIT v0.13 */
char FlagofError_NotExitTrue;    /* flag of Error Happened but not EXIT v0.13 */
char goodORbad;                        /* ver 0.13 for TestWholeFile Mode */

void OneBeep(unsigned int delaytime)
{
   sound(110);
   delay(delaytime);
   nosound();
}
void ErrOutput(char *sf)
{
   cprintf("\r\n%s !!\r\n",sf);
}

enum PROCESS { ABORT, CONTINUE };
int  NormalControlBreak(void)
{
   window(1,7,80,24);
   gotoxy(1,17);
   if(inchinesesystem)  ErrOutput("\r\nϥΪ̤_{");
   else                 ErrOutput("\r\nUser Break");
   FlagofExitError=1;
   exit(0);
   return (ABORT);               /* quit program */
/* return (CONTINUE);            /* continue program */  */
}
void MemoryNotEnough(void *p)
{
   if(p==NULL)
   {
      if(inchinesesystem)  ErrOutput("O餣");
      else                 ErrOutput("Memory Not Enough");
      FlagofExitError=1;
      exit(1);
   }
}
void DDIHeaderError(void)              // ver 0.13
{
   if(inchinesesystem)  ErrOutput("DDI Yƿ~I Х /m:? tX /s:? ոաC");
   else                 ErrOutput("DDI Header Error ! Try /m:? with /s:? .");

   FlagofError_NotExitTrue=1;
   if(FlagofError_NotExit) return;

   FlagofExitError=1;
   exit(1);
}
void ReadFileError(void)
{
   if(inchinesesystem)  ErrOutput("ŪɮɵoͿ~");
   else                 ErrOutput("Reading File Error");

   FlagofError_NotExitTrue=1;
   if(FlagofError_NotExit) return;     // ver 0.13

   FlagofExitError=1;
   exit(1);
}
void SeekFileError(void)
{
   if(inchinesesystem)  ErrOutput("jMɮ׮ɵoͿ~");
   else                 ErrOutput("SEEK file ERROR");

   FlagofError_NotExitTrue=1;
   if(FlagofError_NotExit) return;     // ver 0.13

   FlagofExitError=1;
   exit(1);
}
void Icannothandle(void)
{
   if(inchinesesystem)  ErrOutput("pA٤|ѳoɮ");
   else                 ErrOutput("Sorry, I cannot handle the file");
}
void BootDataError(void)
{
   if(inchinesesystem)  ErrOutput("BOOT ƿ~");
   else                 ErrOutput("BOOT data Error");
}
void ThereareDiffinFAT(void)
{
   if(inchinesesystem)  ErrOutput(" FAT ۦP");
   else                 ErrOutput("There are some different in 2 FAT");
}
void FATCrossLinking(void)
{
   if(inchinesesystem)  ErrOutput(" FAT o{ɮ׸ƭ|");
   else                 ErrOutput("There are cross linking in FAT");
}
void FATDataTooBig(void)
{
   if(inchinesesystem)  ErrOutput("FAT ƶWLd");
   else                 ErrOutput("Some FAT data is out of range");
}
void DiskAlreadyFull(void)
{
   if(inchinesesystem)  ErrOutput("ϺоŶw");
   else                 ErrOutput("Disk Already Full");
   FlagofExitError=1;
   exit(1);
}
void FileOpenError(char *f,char flagexit=0)
{
   if(inchinesesystem)  cprintf("\r\nɮ׶}ҿ~ G %s\r\n",f);
   else                 cprintf("\r\nFile Open Error : %s\r\n",f);
   if(flagexit)   FlagofExitError=1;
   if(flagexit)   exit(1);
}
void WriteFileError(void)
{
   if(inchinesesystem)  ErrOutput("gɮɵoͿ~");
   else                 ErrOutput("Writing File Error");
   FlagofExitError=1;
   exit(1);
}
void MakeDirError(void)
{
   if(inchinesesystem)  ErrOutput("ؤlؿɵoͿ~");
   else                 ErrOutput("Making Target Directory Error");
   FlagofExitError=1;
   exit(1);
}
void NotaDDIfileFormat(char *f)
{
   if(inchinesesystem)  cprintf("\r\n%s iणO@ DDI 榡ɮ !!\r\n",f);
   else                 cprintf("\r\n%s may not be a DDI format file !!\r\n",f);
}
void CannotFindFile(char *f)
{
   if(inchinesesystem)  cprintf("\r\nLk칳o˪ɮ %s !!\r\n",f);
   else                 cprintf("\r\nCan not find file like %s !!\r\n",f);
}
void Pause(void)
{
   char *cstr="YQ~AЫUAΫU Ctrl-C  Ctrl-Break _{ ...";
   char *estr="Press any key to continue, or press Ctrl-C or Ctrl-Break to QUIT ...";
   while(bioskey(1)!=0) bioskey(0);          // Clear Key Buffer
   cprintf("\r\n");
   if(inchinesesystem)  cprintf(cstr);
   else                 cprintf(estr);
   printf("");
   if(bioskey(0)==C_C)  NormalControlBreak();
}

extern unsigned _stklen=4096*8;        /* Length of Stack */
int  *FATchain,totalFAT;               /* FATchain & totalFAT */
char *FATchainUsedMark;                /* FAT chain Used Mark */
FILE *ddifile;                         /* File pointer of source DDI file */
char *DDIfilename;                     /* File name of source DDI file */
char *DDIPATH;                         /* PATH name of source DDI file */
char *CurrentPATH;                     /* Current PATH */
char *TargetPATH;                      /* Target PATH */
char *TargetPATHfilename;              /* Current Target PATH filename */
char *filebuffer;                      /* file buffer                  */
char DDIversion;                       /* Version of DDI file          */
int  trackbufferno;                    /* number of tracks for file buffer */
char FlagofPass;                       /* flag of pass (no overwrite)  */
char FlagofPassNotEnough;              /* flag of pass Dspace not enough */
char FlagofOverwrite;                  /* flag of overwrite            */
char FlagofCheckonly;                  /* flag of check only           */
char FlagofNocmpFAT;                   /* flag of No to compare FAT    */
char FlagofForceExtract;               /* flag of Force extract        */
char FlagofStdformat;                  /* flag of use standard format  */
char FlagofPause;                      /* flag of Pause                */
char FlagofFileExt;                    /* flag of file .EXT specify    */
char FlagofTestFile;                   /* flag of test whole DDI file v0.13 */
int  DDIDisksize;                      /* flag of ddi diskfile specify */
char DDITrackmode;                     /* flag of ddi track mode specify */
int *DDITATchain,totalDDITAT;          /* DDI Track Allocation Table */

/*------------------------------- .DDI format -------------------------------*/
enum FILETYPE { DDI, DCF , DDI5 };
// enum DISKTYPE { Disk_unknow, Disk_360, Disk_1200, Disk_720, Disk_1440,
//                 Disk_2880, Disk_320 };
typedef struct
   {
      char nc1;   /* 01    */
      long tat;
      char nc2;   /* 01    */
   }  DDITAT;

typedef struct
   {
      int  nc1;   /* 01 00 */
      int  tat;
      char nc2;   /* 00    */
   }  DDITATv5;

FILETYPE datafiletype;
DISKTYPE ddifiletype;
unsigned int   BytePerSector;          /* bytes per sector                   */
unsigned char  SectorPerCluster;       /* allocation unit size (in sector)   */
unsigned int   ReservedSector;         /* reserved sectors (starting at 0)   */
unsigned char  FATnumber;              /* number of FAT's on disk            */
unsigned int   ROOTEntry;              /* number of root directory entries   */
unsigned int   TotalSector;            /* total sectors(0 if partition>32Mb) */
unsigned int   SectorPerFAT;           /* sectors per FAT                    */
unsigned int   SectorPerTrack;         /* sectors per track        (DOS 3.0+)*/
unsigned int   TotalTrack;            /* track number of a disk  VER 0.15 */
unsigned int   TotalFiles;             /* total files */
unsigned long  TotalBytes;             /* total bytes */
unsigned int   UnddiFiles;             /* total unddi files */
unsigned long  UnddiBytes;             /* total unddi bytes */
unsigned int   TotalFiles0;            /* total files */
unsigned long  TotalBytes0;            /* total bytes */
unsigned int   UnddiFiles0;            /* total unddi files */
unsigned long  UnddiBytes0;            /* total unddi bytes */
unsigned int   TotalDDIfile;           /* total DDI file specified */
unsigned int   TotalDDIfileGOOD;       /* total Good DDI file specified */
unsigned int   TotalDDIfileBAD;        /* total Bad  DDI file specified */
unsigned int   TotalDCFfile;           /* total DCF file specified */
unsigned int   TotalDCFfileGOOD;       /* total Good DCF file specified */
unsigned int   TotalDCFfileBAD;        /* total Bad  DCF file specified */
DISKTYPE GetDDIfiletype(void)
{
   switch(datafiletype)
   {
      case DCF:
      {
         long fleng=filelength(fileno(ddifile));
         fleng/=512;
         if(fleng==2880)return Disk_1440;
         if(fleng==2400)return Disk_1200;
         if(fleng==1440)return Disk_720 ;
         if(fleng== 720)return Disk_360 ;
         if(fleng== 640)return Disk_320 ;
         return Disk_unknow;
      }
      case DDI5:
      {
         char d5;
         if(fseek(ddifile,66L,SEEK_SET)!=0)SeekFileError();
         if(fread(&d5,sizeof(char),1,ddifile)!=1)ReadFileError();
         switch(d5)
         {
            case 0x1:  return Disk_320;
            case 0x2:  return Disk_360;
            case 0x3:  return Disk_400;
            case 0x4:  return Disk_720;
            case 0x5:  return Disk_800;
            case 0x6:  return Disk_1200;
            case 0x7:  return Disk_1360;
            case 0x8:  return Disk_1440;
            case 0x9:  return Disk_1680;
            case 0xA:  return Disk_2880;
            case 0x0:  default: return Disk_unknow;
         }
      }
      case DDI:   default:
      {
         char d;
         if(fseek(ddifile,10L,SEEK_SET)!=0)SeekFileError();
         if(fread(&d,sizeof(char),1,ddifile)!=1)ReadFileError();
         switch(d)
         {
            case 1:  return Disk_360;
            case 2:  return Disk_1200;
            case 3:  return Disk_720;
            case 4:  return Disk_1440;
            case 5:  return Disk_2880;
            case 6:  return Disk_320;
            case 0: default: return Disk_unknow;
         }
      }
   }
}

char CheckDDIfile1(void)
{
   char SetDefault(DISKTYPE d);
   char id[2];
   if(fseek(ddifile,0L,SEEK_SET)!=0)SeekFileError();
   if(fread(&id,sizeof(char),2,ddifile)!=2)ReadFileError();
   if(!(id[0]=='I' && id[1]=='M')) return 1;                /* Check Level 1 */
   return 0;
}
char CheckDDIfile(void)
{
   char SetDefault(DISKTYPE d);

   SetDefault(ddifiletype);      // set TotalTrack for further check

   DDITAT *t=new DDITAT[TotalTrack];
   MemoryNotEnough(t);  memset(t,0,TotalTrack*sizeof(DDITAT));

   if(fseek(ddifile,100L,SEEK_SET)!=0)SeekFileError();
   if(fread(t,sizeof(DDITAT),TotalTrack,ddifile)!=TotalTrack)ReadFileError();
// b 0.13 HeOϥYKˬdӧP_ɬO_ DDI 
// diskdupe 10.0 (Hק睊) b TotalTrack s@ǥ
// ϱo x2file LkѥX diskdupe 10.0 , 0.15 uP_ TotalTrack C
      for(int i=0;i<TotalTrack;i++)
      {
         DDITATchain[i]=(int)t[i].tat;
         if(DDITATchain[i]>TotalTrack || DDITATchain[i]<0) return 2;  /* Check Level 2 */
      }
      for(i=TotalTrack-1;i>=0;i--)       // Ver 0.13
         if(DDITATchain[i]!=0)break;      // Ver 0.13

      totalDDITAT=i+1;

   for(i=0;i<totalDDITAT;i++)
      if(DDITATchain[i]>totalDDITAT) return 3;              /* Check Level 3 */

   delete [] t;

   return 0;
}
char CheckDDIv5file1(void)
{
   char *idstring="MSD Image Version 1";
   char id[20];
   if(fseek(ddifile,0L,SEEK_SET)!=0)SeekFileError();
   if(fread(&id,sizeof(char),20,ddifile)!=20)ReadFileError(); id[19]='\0';
   if(strcmp(id,idstring)!=0)      return 1;                /* Check Level 1 */
   return 0;
}
char CheckDDIv5file(void)
{
   char SetDefault(DISKTYPE d);

   SetDefault(ddifiletype);      // set TotalTrack,SectorPerTrack for further check

   DDITATv5 *t=new DDITATv5[TotalTrack];
   MemoryNotEnough(t);  memset(t,0,TotalTrack*sizeof(DDITATv5));

   if(fseek(ddifile,(long)0x46,SEEK_SET)!=0)SeekFileError();
   if(fread(t,sizeof(DDITATv5),TotalTrack,ddifile)!=TotalTrack)ReadFileError();

   for(int i=0;i<TotalTrack;i++)
   {
      if(t[i].nc1!=1) DDITATchain[i]=0;
      else            DDITATchain[i]=(int)t[i].tat/(SectorPerTrack*2);
      if(DDITATchain[i]>TotalTrack || DDITATchain[i]<0) return 2;  /* Check Level 2 */
   }
   for(i=TotalTrack-1;i>=0;i--) if(DDITATchain[i]!=0)break;
   totalDDITAT=i+1;

   for(i=0;i<totalDDITAT;i++)
      if(DDITATchain[i]>totalDDITAT) return 3;              /* Check Level 3 */

   delete [] t;

   return 0;
}

void fReadDiskSector(void *buff,int sectornumber,long sectoroffset,FILE *fp)
{
   int i;
   switch(datafiletype)
   {
      case DCF:
         for(i=0;i<sectornumber;i++)
         {
            if(fseek(fp,(sectoroffset+i)*BytePerSector,SEEK_SET)!=0)SeekFileError();
            if(fread((char *)buff+i*BytePerSector,BytePerSector,1,fp)!=1)ReadFileError();
         }
         break;

      case DDI5:
         for(i=0;i<sectornumber;i++)
         {
            long TATseg=DDITATchain[(sectoroffset+i)/SectorPerTrack];
            long TAToff=(sectoroffset+i)%SectorPerTrack;
            long ddifileoffset=0x500L     // DDIv5 Headerlength=0x500
                              +(TATseg*SectorPerTrack+TAToff)*BytePerSector;
            if(TATseg>totalDDITAT) DDIHeaderError(); // ver 0.13
            if(fseek(fp,ddifileoffset,SEEK_SET)!=0)SeekFileError();
            if(fread((char *)buff+i*BytePerSector,BytePerSector,1,fp)!=1)ReadFileError();
         }
         break;

      case DDI: default :
         for(i=0;i<sectornumber;i++)
         {
            long TATseg=DDITATchain[(sectoroffset+i)/SectorPerTrack];
            long TAToff=(sectoroffset+i)%SectorPerTrack;
            long ddifileoffset=(TATseg*SectorPerTrack+TAToff)*BytePerSector;
            if(TATseg==0 || TATseg>totalDDITAT) DDIHeaderError(); // ver 0.13
            if(fseek(fp,ddifileoffset,SEEK_SET)!=0)SeekFileError();
            if(fread((char *)buff+i*BytePerSector,BytePerSector,1,fp)!=1)ReadFileError();
         }
         break;
   }
}

void showfilestatus(Directory &d)
{
/*-----------------------------------------------------------------------------
extact path name           filename ext  filesize   filedate filetime  attrib
=========================  ========.===  =========  ======== ========  ======
printf("%25.25s  %8.8s.%3.3s  %9.9s  %8.8s %8.8s %6.6s",
-----------------------------------------------------------------------------*/
   cprintf("\r\n%-25.25s  %8.8s.%3.3s  %9ld  %02d-%02d-%02d %02d:%02d:%02d  %s%s%s%s%s%s",
         (strlen(TargetPATH)<=25)?TargetPATH:(TargetPATH+strlen(TargetPATH)-25),
         d.filename, d.fileext, d.filesize,
         d.fd.mon, d.fd.day, d.fd.year+80,
         d.ft.hour, d.ft.min, d.ft.sec*2,
         (d.fa.archive  ==1)?"A":" ",
         (d.fa.readonly ==1)?"R":" ",
         (d.fa.system   ==1)?"S":" ",
         (d.fa.hidden   ==1)?"H":" ",
         (d.fa.directory==1)?"D":" ",
         (d.fa.volume   ==1)?"V":" " );
   gotoxy(1,wherey());
}
void showfilesize(int fs)
{
   static long ffs;
   if(fs==0)ffs=0; else ffs+=fs;
   gotoxy(42,wherey());printf("%9ld",ffs);
}
void VerifyThisFile(Directory &d)
{
   if(goodORbad==1)return;
   if(d.fa.directory==1)return;

   strcpy(TargetPATHfilename,TargetPATH);
   addpathname(TargetPATHfilename,d.filename,d.fileext);
   TargetPATHfilename[strlen(TargetPATHfilename)-1]='\0';

   unsigned int stcluster=d.startcluster;
   int filebufferused;

   FlagofError_NotExitTrue=0;
   showfilesize(0);  filebufferused=0;
   if(d.fa.volume!=1 && d.filesize>0)
      while(1)
      {
         ReadFileCluster(filebuffer+filebufferused*BytePerSector*SectorPerCluster,stcluster);
         if(goodORbad==1)break;        // Test if ReadFileCluster() Error !
         if(FlagofError_NotExitTrue!=0)   {  goodORbad=1;   break;   }
         filebufferused++;
         unsigned int writebyte;
         if(FATchain[stcluster]>0xFF0)          /* test if <EOF> */
         {
            if(d.filesize%(BytePerSector*SectorPerCluster)!=0)
               showfilesize(d.filesize%(BytePerSector*SectorPerCluster));
            else
               showfilesize(BytePerSector*SectorPerCluster);
            break;
         }
         else
         {
            if(filebufferused>=trackbufferno)   /* Need to flush file buffer */
               filebufferused=0;
         }
         showfilesize(BytePerSector*SectorPerCluster);
         stcluster=FATchain[stcluster];
      }

   if(FlagofError_NotExitTrue!=0) return;
   UnddiFiles++;              UnddiFiles0++;
   UnddiBytes+=d.filesize;    UnddiBytes0+=d.filesize;
}
void SaveThisFile(Directory &d)
{
   if(d.fa.directory==1)return;

   strcpy(TargetPATHfilename,TargetPATH);
   addpathname(TargetPATHfilename,d.filename,d.fileext);
   TargetPATHfilename[strlen(TargetPATHfilename)-1]='\0';

   char driver=(TargetPATH[1]==':')?TargetPATH[0]:0;
   long frees=GetDiskFreeSpace(driver);
   if(frees==0) DiskAlreadyFull();
   if(d.filesize>frees)
   {
      int ch=0;
      gotoxy(1,wherey()); cprintf("%79.79s"," "); gotoxy(1,wherey());
      if(FlagofPassNotEnough) {  gotoxy(1,wherey()-1);   return;  }

      if(inchinesesystem)
         cprintf("%-26.26s ϺоŶw ! (P)L (S)L (Q) ? ",
                  (strlen(TargetPATHfilename)<=26)?TargetPATHfilename:(TargetPATHfilename+strlen(TargetPATHfilename)-26));
      else
         cprintf("%-26.26s Free Space Not Enough !  ski(P)all (S)kip (Q)uit ? ",
                  (strlen(TargetPATHfilename)<=26)?TargetPATHfilename:(TargetPATHfilename+strlen(TargetPATHfilename)-26));
      while(bioskey(1)!=0) bioskey(0);
      while(ch==0)
         switch(bioskey(0))
         {
            case N_S: case S_S: putch('S'); ch=1; return;
            case N_P: case S_P: putch('P'); ch=1; FlagofPassNotEnough=1; return;
            case N_Q: case S_Q: putch('Q'); ch=1;
            case C_C:           NormalControlBreak();
            default:                        ch=0; break;
         }
      gotoxy(1,wherey()); cprintf("%79.79s"," "); gotoxy(1,wherey()-1);
      showfilestatus(d);
   }

   if(!FlagofOverwrite)
      if(access(TargetPATHfilename,0)==0)
      {
         int ch=0;
         gotoxy(1,wherey()); cprintf("%79.79s"," "); gotoxy(1,wherey());
         if(FlagofPass) {  gotoxy(1,wherey()-1);   return;  }

         if(inchinesesystem)
            cprintf("%-22.22s ɮפwsb ! (P)L (S)L (O)\\g (A)\\g ? ",
                     (strlen(TargetPATHfilename)<=22)?TargetPATHfilename:(TargetPATHfilename+strlen(TargetPATHfilename)-22));
         else
            cprintf("%-22.22s Already exist ! ski(P)all (S)kip (O)verwrite (A)ll   ? ",
                     (strlen(TargetPATHfilename)<=22)?TargetPATHfilename:(TargetPATHfilename+strlen(TargetPATHfilename)-22));
         while(bioskey(1)!=0) bioskey(0);
         while(ch==0)
            switch(bioskey(0))
            {
               case N_S: case S_S: putch('S'); ch=1; return;
               case N_O: case S_O: putch('O'); ch=1; break;
               case N_A: case S_A: putch('A'); ch=1; FlagofOverwrite=1; break;
               case N_P: case S_P: putch('P'); ch=1; FlagofPass=1; return;
               case C_C:           NormalControlBreak();
               default:                        ch=0; break;
            }
         gotoxy(1,wherey()); cprintf("%79.79s"," "); gotoxy(1,wherey()-1);
         showfilestatus(d);
      }

   unsigned int stcluster=d.startcluster;
   int filebufferused;
   int thishandle;

   thishandle=open(TargetPATHfilename,O_WRONLY|O_CREAT|O_BINARY,S_IWRITE);
   if(thishandle==-1)   FileOpenError(TargetPATHfilename,1);

   showfilesize(0);  filebufferused=0;
   if(d.fa.volume!=1 && d.filesize>0)
      while(1)
      {
         ReadFileCluster(filebuffer+filebufferused*BytePerSector*SectorPerCluster,stcluster);
         if(goodORbad==1)break;        // Test if ReadFileCluster() Error !
         filebufferused++;
         unsigned int writebyte;
         if(FATchain[stcluster]>0xFF0)          /* test if <EOF> */
         {
            if(d.filesize%(BytePerSector*SectorPerCluster)!=0)
            {
               writebyte=write(thishandle,filebuffer,((unsigned)filebufferused-1)*(BytePerSector*SectorPerCluster)
                                                   +d.filesize%(BytePerSector*SectorPerCluster));
               if(writebyte!= ((unsigned)filebufferused-1)*(BytePerSector*SectorPerCluster)
                              +d.filesize%(BytePerSector*SectorPerCluster))
                  WriteFileError();
               showfilesize(d.filesize%(BytePerSector*SectorPerCluster));
            }
            else
            {
               writebyte=write(thishandle,filebuffer,(unsigned)filebufferused*BytePerSector*SectorPerCluster);
               if(writebyte!=(unsigned)filebufferused*(unsigned)BytePerSector*(unsigned)SectorPerCluster)
                  WriteFileError();
               showfilesize(BytePerSector*SectorPerCluster);
            }
            break;
         }
         else
         {
            if(filebufferused>=trackbufferno)   /* Need to flush file buffer */
            {
               writebyte=write(thishandle,filebuffer,(unsigned)filebufferused*BytePerSector*SectorPerCluster);
               if(writebyte!=(unsigned)filebufferused*(unsigned)BytePerSector*(unsigned)SectorPerCluster)
                     WriteFileError();
               filebufferused=0;
            }
         }
         showfilesize(BytePerSector*SectorPerCluster);
         stcluster=FATchain[stcluster];
      }

   SetFileDateTime(thishandle,d.filedate,d.filetime);
   close(thishandle);
   SetFileAttribute(TargetPATHfilename,d.fileattr);

   UnddiFiles++;              UnddiFiles0++;
   UnddiBytes+=d.filesize;    UnddiBytes0+=d.filesize;
}
void showdir(Directory *d,int numberofd)
{
   void ShowDirectory(unsigned int);
   if(goodORbad==1)return;                      // ver 0.13
   int i;
   for(i=0;i<numberofd;i++)
   {
      if(d[i].filename[0]=='\0')break;          /* End of Entry */
      if(d[i].filename[0]=='')continue;        /* file has been deleted */
      if(d[i].filename[0]=='.')continue;        /* file is a directory */
      showfilestatus(d[i]);
      if(d[i].fa.directory!=1)
      {
         TotalFiles++; TotalBytes+=d[i].filesize;
         TotalFiles0++; TotalBytes0+=d[i].filesize;
      }
      if(!FlagofCheckonly)
         if(!FlagofTestFile)SaveThisFile(d[i]);    // ver 0.13
         else               VerifyThisFile(d[i]);  // ver 0.13
      if(goodORbad==1)return;                      // ver 0.13
      if(d[i].fa.directory==1 && d[i].filename[0]!='.' && d[i].filename[0]!='')
      {
         addpathname(TargetPATH,d[i].filename,d[i].fileext);
         if(FlagofCheckonly==0 && FlagofTestFile==0)
         {
            struct date dn,df;
            struct time tn,tf;
            df.da_year=d[i].fd.year+1980;df.da_mon=d[i].fd.mon;df.da_day =d[i].fd.day;
            tf.ti_min=d[i].ft.min;tf.ti_hour=d[i].ft.hour;tf.ti_sec=d[i].ft.sec*2;tf.ti_hund=0;
            getdate(&dn);setdate(&df);
            gettime(&tn);settime(&tf);
            MakeDir(TargetPATH);
            settime(&tn);setdate(&dn);
         }
         ShowDirectory(d[i].startcluster);
         killpathname(TargetPATH);
      }
      if(goodORbad==1)break;  // Test if ShowDir()/ReadFileCluster() Error !
   }
}
void ShowDirectory(unsigned int startclus)
{
   int i=BytePerSector*SectorPerCluster/sizeof(Directory);
   Directory *d=new Directory[i];   MemoryNotEnough(d);
   while(1)
   {
      ReadFileCluster((void *)d,startclus);
      if(goodORbad==1)break;        // Test if ReadFileCluster() Error !
      showdir(d,i);
      if(FATchain[startclus]>0xFF0) break;         /* test if <EOF> */
      startclus=FATchain[startclus];
   }
   delete [] d;
}
void ShowROOT(void)
{
   Directory *d=new Directory[ROOTEntry];    MemoryNotEnough(d);

   fReadDiskSector(d,ROOTEntry/(BytePerSector/sizeof(Directory)),
             1L+FATnumber*SectorPerFAT,ddifile);

   showdir(d,ROOTEntry);
   delete [] d;
}

char CheckChineseSystem(void)
{
   asm{  mov   ax,09100h
         mov   bx,0
         int   10h

         cmp   bx,0
         je    NotInET

         mov   ah,80h
         mov   al,'N'
         int   10h      };

   return 1;

NotInET:
   return 0;
}

char *Eusage="USAGE :  %s  [options]  DDIfile[.ddi]  [[drive:][\\]path]\n"
             "options:\n"
             "\t/o\tOverwrite if file already exist\n"
             "\t/c\tCheck only and show the files in DDI\n"
             "\t/t\tTest the whole DDI file\n"
             "\t/p\tPause if more than one DDIfile are specified\n"
             "\t/n\tNot to compare two FATs\n"
             "\t/f\tForce extracting file (Don't care ERROR FAT)\n"
             "\t/s\tuse Standard floppy disk format\n"
             "\t/d:[no]\tDisk size contain in DDI file\n"
             "\t\tno:1-->320Kb  2-->360Kb  3-->400Kb  4-->720Kb  5-->800Kb \n"
             "\t\t   6-->1200Kb 7-->1360Kb 8-->1440Kb 9-->1680Kb 10-->2880Kb\n"
             "\t/m:[no]\tthe Mode of the DDI file\n"
                 "\t\tno:\t1 --> Normal Mode (default)\t2 --> Unusual Mode\n"
             "EXAMPLE:\n"
             "\t%s  /p test*.ddi                  --> Check only\n"
             "\t%s  /t test*.ddi                  --> Completely check\n"
             "\t%s  test*.ddi c:\\test             --> UnDDI to c:\\test\n\n"
             "For more information please see the english document file.\n";

char *Cusage="ΪkG %s  [ﶵ]  DDIɦW[.ddi]  [[ϺоW:][\\]ؿ]\n"
             "\n"
             "ﶵG"
             "\t/o\t\tɮפwsbN|\\g\n"
             "\t/c\t\tuˬdèqX DDI ɦW\n"
             "\t/t\t\tվ DDI ɮ\n"
             "\t/p\t\tYwh DDI ɡAh|bBzCɫȰ@U\n"
             "\t/n\t\t FAT O_ۦP\n"
             "\t/f\t\tjɡA FAT O_D\n"
             "\t/s\t\tϥμзǳnЪ榡\n"
             "\t/d:[N]\tDDI ɤҧtƪjp\n"
                 "\t\t\tN:\t1 --> 360  Kb\t2 --> 1200 Kb\t3 --> 720  Kb\n"
                      "\t\t\t\t4 --> 1440 Kb\t5 --> 2880 Kb\t6 --> 320  Kb\n"
             "\t/m:[N]\tDDI YҦAtXѼ /d:? @_ϥ\n"
                 "\t\t\tN:\t1 --> @Ҧ (YNw)\t2 --> `Ҧ\n\n"
             "dҡG"
             "\t%s  /p test*.ddi                  --> Check only\n"
             "\t%s  /t test*.ddi                  --> Completely check\n"
             "\t%s  test*.ddi c:\\test             --> UnDDI to c:\\test\n\n"
             "YQDhAбzŬݬݤ廡C\n";

char *pline  ="-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-\n";
char *pline2 ="=========================";
char *Eauther="X2File        Version 0.15          Dec.31,1995             by : Lee Dong-Liang\n";
char *Cauther="X2File       0.15             KQ|~ Q ʤ@                byG ɼ\n";
char *Eheader="target path name           filename ext  filesize   filedate filetime  attrib";
char *Cheader="Ѷ}ؿ                 D  W ƦW ɮפjp   ɮפ ɮ׮ɶ    ";

void ShowTitle(void)
{
   printf(pline);
   if(inchinesesystem)printf(Cauther);
   else               printf(Eauther);
   printf(pline);
}
void ShowHeader(void)
{
/*-----------------------------------------------------------------------------
extact path name           filename ext  filesize   filedate filetime  attrib
=========================  ========.===  =========  ======== ========  ======
-----------------------------------------------------------------------------*/
   if(inchinesesystem)cprintf("\r\n%s\r\n",Cheader);
   else               cprintf("\r\n%s\r\n",Eheader);
   cprintf("%25.25s  %8.8s.%3.3s  %9.9s  %8.8s %8.8s  %6.6s",pline2,pline2,pline2,pline2,pline2,pline2,pline2);
}
void Help(char *ex)
{
   int i;
   for(i=strlen(ex);i>=0;i--)
      if(ex[i]=='\\'){i++; break;}
   char *s=&ex[i];
   if(inchinesesystem)printf(Cusage,s,s,s,s,s);
   else               printf(Eusage,s,s,s,s,s);
   exit(1);
}
void FlagSetting(int argc_,char *argv_[])
{
   if(argc_<2)  Help(argv_[0]);
   int j=0;
   for(int i=1;i<argc_;i++)
   {
      if(argv_[i][0]=='/')       /* This is a option */
      {
         switch(argv_[i][1])
         {
            case 'O': case 'o':  FlagofOverwrite=1;   break;
            case 'C': case 'c':  FlagofCheckonly=1;   break;
            case 'T': case 't':  FlagofTestFile =1;   break;   /* ver 0.13 */
            case 'P': case 'p':  FlagofPause=1;       break;
            case 'N': case 'n':  FlagofNocmpFAT=1;    break;
            case 'F': case 'f':  FlagofForceExtract=1;break;   /* ver 0.14 */
            case 'S': case 's':  FlagofStdformat=1;   break;
            case 'D': case 'd':  if(argv_[i][2]==':') DDIDisksize=atoi(&argv_[i][3]);
                                 switch(DDIDisksize)
                                 {
                                    case 0x1:  DDIDisksize=Disk_320;    break;
                                    case 0x2:  DDIDisksize=Disk_360;    break;
                                    case 0x3:  DDIDisksize=Disk_400;    break;
                                    case 0x4:  DDIDisksize=Disk_720;    break;
                                    case 0x5:  DDIDisksize=Disk_800;    break;
                                    case 0x6:  DDIDisksize=Disk_1200;   break;
                                    case 0x7:  DDIDisksize=Disk_1360;   break;
                                    case 0x8:  DDIDisksize=Disk_1440;   break;
                                    case 0x9:  DDIDisksize=Disk_1680;   break;
                                    case 0xA:  DDIDisksize=Disk_2880;   break;
                                    case 0x0:  default: DDIDisksize=Disk_unknow; break;
                                 }
                                 break;
            case 'M': case 'm':  if(argv_[i][2]==':') DDITrackmode=atoi(&argv_[i][3]);
                                 if(DDITrackmode<1 || DDITrackmode>2)DDITrackmode=1;
                                 if(DDIDisksize==0)DDIDisksize=Disk_1440; /* default 1440Kb */
                                 break;
            default :            Help(argv_[0]);
         }
      }
      else                       /* This is a option */
      {
         j++;
         if(j==1)
         {
            strncpy(DDIfilename,argv_[i],99),DDIfilename[99]='\0';
            int s=strlen(DDIfilename);
//          if(DDIfilename[s-4]!='.')strcat(DDIfilename,".DDI");
            if(DDIfilename[s-4]=='.')FlagofFileExt=1;
            if(DDIfilename[s-2]=='.' && DDIfilename[s-1]=='*')
               DDIfilename[s-2]='\0';     /* if EXT is '*' then detect all */
            DDIPATH[0]='\0';
            for(s=strlen(DDIfilename)-1;s>=0;s--)
               if(DDIfilename[s]=='\\' || DDIfilename[s]==':')
               {
                  s++;
                  char t=DDIfilename[s];     /* temp char buffer */
                  DDIfilename[s]='\0';
                  strncpy(DDIPATH,DDIfilename,79); DDIPATH[79]='\0';
                  DDIfilename[s]=t;
                  break;
               }
         }
         if(j==2)
         {
            strncpy(TargetPATH,argv_[i],299),TargetPATH[299]='\0';
            if(TargetPATH[strlen(TargetPATH)-1]!='\\')
               if(TargetPATH[strlen(TargetPATH)-1]==':')
                  strcat(TargetPATH,".\\");
               else
                  strcat(TargetPATH,"\\");
         }
         if(j>=3) Help(argv_[0]);
      }
   }
   if(j==0) Help(argv_[0]);
   if(FlagofTestFile==1) FlagofCheckonly=0;           /* ver 0.13 */
   FlagofError_NotExit=FlagofTestFile;    /* flag of Error but not EXIT v0.13 */

   CurrentPATH=new char[300];
   strcpy(CurrentPATH,"D:\\");CurrentPATH[0]='A'+getdisk();getcurdir(0,CurrentPATH+3);
   if(CurrentPATH[strlen(CurrentPATH)-1]!='\\')strcat(CurrentPATH,"\\");
   if(j<2)
   {
      strcpy(TargetPATH,CurrentPATH);
      FlagofCheckonly=1;                              /* ver 0.11 */
      if(FlagofTestFile==1) FlagofCheckonly=0;        /* ver 0.13 */
   }
   if(strchr(TargetPATH,':')==NULL)
   {
      if(TargetPATH[0]=='\\')
      {
         memmove(&TargetPATH[2],TargetPATH,297);
         TargetPATH[0]='A'+getdisk();
         TargetPATH[1]=':';
      }
      else
      {
         char *st=new char[300];
         strcpy(st,TargetPATH);
         strcpy(TargetPATH,CurrentPATH);
         strcat(TargetPATH,st);
         delete [] st;
      }
   }

   int len_trpath=strlen(TargetPATH);
   TargetPATH[len_trpath-1]='\0';
   if(chdir(TargetPATH)!=0)
   {
      int i,j;
      int *tpos=new int[20];
      for(j=0,i=len_trpath-2;i>=0;i--)
         if(TargetPATH[i]=='\\')tpos[j++]=i;
      for(i=0;i<j;i++)
      {
         if(TargetPATH[tpos[i]-1]==':')
            break;
         TargetPATH[tpos[i]]='\0';
         if(chdir(TargetPATH)==0)
            break;
      }
      if(i==j)i--;
      for(j=i;j>=0;j--)
      {
         TargetPATH[tpos[j]]='\\';
         if(mkdir(TargetPATH)!=0) MakeDirError();
      }
      chdir(TargetPATH);
      delete [] tpos;
   }
   TargetPATH[len_trpath-1]='\\';

   if(CurrentPATH[strlen(CurrentPATH)-2]!=':') CurrentPATH[strlen(CurrentPATH)-1]='\0';
   chdir(CurrentPATH);
   delete [] CurrentPATH;
}

void ShowStatusofFiles(int tf,long tb,int uf,long ub)
{
/*-----------------------------------------------------------------------------
=========================  ========.===  =========  ======== ========  ======
   Total files : 123456    Total bytes : 123456789
   unddi files : 123456    unddi bytes : 123456789
   Total DDIs  : 123456    GOOD DDIs   : 123456789  BAD! DDIs   : 123456789
     `ɮ׼ G 123456      `줸 G 123456789
 ҸѪɮ׼ G 123456  ҸѪ줸 G 123456789
  @ DDI  G 123456   n DDI  G 123456789   a DDI  G 123456789
-----------------------------------------------------------------------------*/
   cprintf("\r\n%25.25s  %8.8s.%3.3s  %9.9s  %8.8s %8.8s  %6.6s\r\n",pline2,pline2,pline2,pline2,pline2,pline2,pline2);
   if(inchinesesystem)
   {
      cprintf("     `ɮ׼ G %6u      `줸 G %9ld\r\n",tf,tb);
      if(FlagofCheckonly==0 && FlagofTestFile==0)
         cprintf(" ҸѪɮ׼ G %6u  ҸѪ줸 G %9ld\r\n",uf,ub);
   }
   else
   {
      cprintf("   Total files : %6u    Total bytes : %9ld\r\n",tf,tb);
      if(FlagofCheckonly==0 && FlagofTestFile==0)
         cprintf("   unddi files : %6u    unddi bytes : %9ld\r\n",uf,ub);
   }
}
void ExitRoutine(void)
{
   if(!((TotalDDIfile+TotalDCFfile)==1 && FlagofExitError==0))
      ShowStatusofFiles(TotalFiles,TotalBytes,UnddiFiles,UnddiBytes);
   if(TotalDDIfile>1 || (TotalDDIfile==1 && TotalDCFfile>=1))
      if(inchinesesystem)
         cprintf("  @ DDI  G %6u   n DDI  G %9u   a DDI  G %6u\r\n",
                  TotalDDIfile, TotalDDIfileGOOD, TotalDDIfileBAD);
      else
         cprintf("   Total DDIs  : %6u     GOOD DDIs  : %9u      BAD! DDIs : %6u\r\n",
                  TotalDDIfile, TotalDDIfileGOOD, TotalDDIfileBAD);
   if(TotalDCFfile>1 || (TotalDCFfile==1 && TotalDDIfile>=1))
      if(inchinesesystem)
         cprintf("  @ DCF  G %6u   n DCF  G %9u   a DCF  G %6u\r\n",
                  TotalDCFfile, TotalDCFfileGOOD, TotalDCFfileBAD);
      else
         cprintf("   Total DCFs  : %6u     GOOD DCFs  : %9u      BAD! DCFs : %6u\r\n",
                  TotalDCFfile, TotalDCFfileGOOD, TotalDCFfileBAD);
   delete [] TargetPATHfilename;
   delete [] TargetPATH;
   delete [] DDIfilename;
   delete [] DDIPATH;
   if(ddifile!=NULL) fclose(ddifile);
}


void DealWithDatafile(int &count,int titlebottom)
{
   struct ffblk F;
   union{ FileAttr fa;
          char charfa;  };
   int done=findfirst(DDIfilename,&F,0);
   if(!done) if(goodORbad && datafiletype==DCF)  Pause();   // DDI error pause when switch into DCF
   while(!done)
   {
      int  i,j;
//    char goodORbad;
//    DISKTYPE ddifiletype;
      BOOTSEC b;

      filebuffer=NULL; FATchain=NULL; DDITATchain=NULL; FATchainUsedMark=NULL;
      ddifile=NULL;
      goodORbad=0;

      charfa=F.ff_attrib;
      if(fa.volume==1 || fa.directory==1)
      {
         done=findnext(&F);
         continue;
      }
      count++;
      strcpy(DDIfilename,DDIPATH);
      strcat(DDIfilename,F.ff_name);
      window(1,titlebottom,80,24);
      clrscr();
      gotoxy(1,1);
      switch(datafiletype)
      {
         case DCF:
            TotalDCFfile++;
            if(inchinesesystem)  printf("DCFɦW : %13.13s\t\t",F.ff_name);
            else                 printf("DCFfile : %13.13s\t\t",F.ff_name);
            break;

         case DDI:   case DDI5:  default:
            TotalDDIfile++;
            if(inchinesesystem)  printf("DDIɦW : %13.13s\t\t",F.ff_name);
            else                 printf("DDIfile : %13.13s\t\t",F.ff_name);
            break;
      }
      int headerbottom;
      for(i=0;i<1;i++)           /* Null Loop -- for using Ctrl-Break */
      {
         if((ddifile=fopen(DDIfilename,"rb"))==NULL)
         {
            FileOpenError(DDIfilename);   goodORbad=1;   break;
         }
         TotalFiles0=UnddiFiles0=0; TotalBytes0=UnddiBytes0=0L;

         // Check if the DDI datafile is NewVersion
         if(CheckDDIv5file1()==0) datafiletype=DDI5;

         if(DDIDisksize==0) ddifiletype=GetDDIfiletype();
         else               ddifiletype=(DISKTYPE)DDIDisksize;

         DDITATchain=new int[MacTrackNumber];   MemoryNotEnough(DDITATchain);

         if(datafiletype==DDI)                     /* check DDI */
         {
            if(DDITrackmode==0)                    /* Track no specify */
               if((goodORbad=CheckDDIfile())!=0)
               {
                  NotaDDIfileFormat(DDIfilename);  break;
               }
            if(DDITrackmode==2)                    /* Track is Unusual Mode */
            {                                   /* 1,3,2,5,4,7,6,9,8,11,10  */
               for(j=0;j<MacTrackNumber;j++)    /* 0,1,2,3,4,5,6,7,8,9 ,10  */
                  if(j==0)       DDITATchain[j]=j+1;
                  else if(j%2==0)DDITATchain[j]=j;
                       else      DDITATchain[j]=j+2;
               totalDDITAT=j;
            }
            if(DDITrackmode!=0 && DDITrackmode!=2) /* Track is Normal Mode */
            {
               DDITrackmode=1;
               for(j=0;j<MacTrackNumber;j++) DDITATchain[j]=j+1;
               totalDDITAT=j;
            }
         }
         else if(datafiletype==DDI5)               /* check DDIv5 */
         {
            if((goodORbad=CheckDDIv5file())!=0)
            {
               NotaDDIfileFormat(DDIfilename);  break;
            }
         }

         gotoxy(32,1);
         if(inchinesesystem)  printf("ҧtƤjp (Kb) : %5d\t",ddifiletype);
         else                 printf("Disk Size is (Kb) : %5d\t",ddifiletype);

         ShowHeader();
         headerbottom=wherey()+titlebottom;
         window(1,headerbottom,80,24);

         if((goodORbad=SetDefault(ddifiletype))!=0)break;
         if((goodORbad=ReadBOOT(&b,ddifiletype))!=0)  break;
         if(FlagofStdformat==0) ResetParameter(b); // ReadBOOT data to reset

         if(FlagofNocmpFAT==0) if(FATnumber>1)
            if((goodORbad=CompareFAT())!=0)  break;

         totalFAT=SectorPerFAT*BytePerSector*2/3;
         FATchain=new int[totalFAT];            MemoryNotEnough(FATchain);
         if((goodORbad=ConvertFAT(FATchain,totalFAT))!=0) break;

         FATchainUsedMark=new char[totalFAT];   MemoryNotEnough(FATchainUsedMark);
         memset(FATchainUsedMark,0,sizeof(char)*totalFAT);

         trackbufferno=(coreleft()-90000L)/(SectorPerCluster*BytePerSector);
         if(trackbufferno*SectorPerCluster>120) trackbufferno=120/SectorPerCluster;
         if(trackbufferno<1) trackbufferno=1;

         filebuffer=(char *)farcalloc(trackbufferno*SectorPerCluster,BytePerSector*sizeof(char));
         MemoryNotEnough(filebuffer);

         ShowROOT();
         if(goodORbad==1)break;

         ShowStatusofFiles(TotalFiles0,TotalBytes0,UnddiFiles0,UnddiBytes0);
         goodORbad=(TotalBytes0<=(unsigned long)ddifiletype*1024L)?0:1;
      }
      int statusendx=wherex(),statusendy=wherey();
      window(1,titlebottom,80,24);
      gotoxy(66,1);
      if(inchinesesystem)  printf("  A : %s\n",(goodORbad==0)?"n":"a");
      else                 printf("Status : %s\n",(goodORbad==0)?"GOOD":"BAD!");

      if(goodORbad)  switch(datafiletype)
                     {
                        case DCF: TotalDCFfileBAD++;  break;
                        case DDI: case DDI5:
                        default:  TotalDDIfileBAD++;  break;
                     }
      else           switch(datafiletype)
                     {
                        case DCF: TotalDCFfileGOOD++; break;
                        case DDI: case DDI5:
                        default:  TotalDDIfileGOOD++; break;
                     }
      if(goodORbad)  OneBeep(300);
      window(1,headerbottom,80,24);
      gotoxy(statusendx,statusendy);
      if(filebuffer!=NULL)       farfree(filebuffer);
      if(FATchainUsedMark!=NULL) delete [] FATchainUsedMark;
      if(FATchain!=NULL)         delete [] FATchain;
      if(DDITATchain!=NULL)      delete [] DDITATchain;

      if((done=findnext(&F))==0)
         if(FlagofPause)   Pause();
         else if(goodORbad)  Pause();
      if(ddifile!=NULL) fclose(ddifile);
   }
}

void main(int argc,char *argv[])
{
   int titlebottom;
   clrscr();
   ctrlbrk(NormalControlBreak);                 /* Set Ctrl-Break function  */

   inchinesesystem=CheckChineseSystem();
   ShowTitle();
   titlebottom=wherey();

   DDIPATH=new char[80];
   DDIfilename=new char[100];
   TargetPATH=new char[300];
   TargetPATHfilename=new char[320];
   FlagSetting(argc,argv);

   atexit(ExitRoutine);

   int count=0;

   if(FlagofFileExt==1)
   {
      int slen=strlen(DDIfilename);
      if(strnicmp(&DDIfilename[slen-3],"DCF",3)==0) datafiletype=DCF;
      else                                          datafiletype=DDI;
      DealWithDatafile(count,titlebottom);
   }
   else
   {
      char *tempDDIfilename=new char[100];
      strcpy(tempDDIfilename,DDIfilename);
      strcat(DDIfilename,".DDI");
      datafiletype=DDI;
      DealWithDatafile(count,titlebottom);

      strcpy(DDIfilename,tempDDIfilename);
      strcat(DDIfilename,".DCF");
      datafiletype=DCF;
      DealWithDatafile(count,titlebottom);
   }
   if(count==0)   CannotFindFile(DDIfilename);

   return;
}

/*-----------------------------------------------------------------------------
                       Common Floppy Disk Formats
               Supporting          SectorsĿ        Entries
          Disk    DOS              per  per  per   per   per   Total
          Type   Vers  Sides Trks  TRK  FAT  DIR Cluster DIR  Sectors
        
        5 160k  (1.0)   1   (40)   8    1    4     1     64     320
        5 320k  (1.1)   2   (40)   8    1    7     2    112     640
        5 180k  (2.0)   1   (40)   9    2    4     1     64     360
        5 360k  (2.0)   2   (40)   9    2    7     2    112     720
        5 1.2M  (3.0)   2   (80)  15    7   14     1    224    2400
        5 1.36M (?.?)   2   (80)  17    8   ??     1    224    2720
        3 720k  (3.2)   2   (80)   9    3    7     2    112    1440
        3 1.44M (3.3)   2   (80)  18    9   14     1    224    2880
        3 1.68M (?.?)   2   (80)  21   10   ??     1    224    3360
        3 2.88M (?.?)   2   (80)  36    9   15     2    240    5760

Area  1440 Kb total  1200 Kb total  720  Kb total  360  Kb total
====  ======= =====  ======= =====  ======= =====  ======= =====
BOOT   0          1   0          1   0          1   0          1
FAT1   1-9        9   1-7        7   1-5        5   1-3        3
FAT2  10-18       9   8-14       7   6-10       5   4-6        3
ROOT  19-32      14  15-28      14  11-17       7   7-13       7
DATA  33-2879  2847  29-2399  2371  18-1439  1422  14-719    706
====  ======= =====  ======= =====  ======= =====  ======= =====
Diff  +31            +27            +16            +12

Area  2880 Kb total  320  Kb total
====  ======= =====  ======= =====
BOOT   0          1   0          1
FAT1   1-9        9   1-
FAT2  10-18       9    -
ROOT  19-33      15    -
DATA  34-5759  5726    -
====  ======= =====  ======= =====
Diff  +32                           Sector = Cluster + Diff

               2880 Kb  1440 Kb  1200 Kb  720  Kb  360  Kb
=============  =======  =======  =======  =======  =======
DDIoffset           36       18       15        9        9  = Sector per Track

DDI disk size : offset 000A   byte
               360  Kb  1200 Kb  720  Kb  1440 Kb  2880 Kb  320  Kb
=============  =======  =======  =======  =======  =======  =======
ID character    = 0x1   = 0x2   = 0x3   = 0x4   = 0x5   = 0x6

+------------------------------------+
| Boot Sector                        |
+------------------------------------+
| FAT1                               |
+------------------------------------+
| FAT2                               |
+------------------------------------+
| ROOT                               |
+------------------------------------+
| Data Area (cluster 2)              |
|                                    |
+------------------------------------+
-----------------------------------------------------------------------------*/
